Index: sansmodels/src/sans/models/c_extensions/libmultifunc/librefl.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/libmultifunc/librefl.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
+++ sansmodels/src/sans/models/c_extensions/libmultifunc/librefl.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -0,0 +1,338 @@
+// The original code, of which work was not DANSE funded,
+// was provided by J. Cho.
+// And modified to fit sansmodels/sansview: JC
+
+#include <math.h>
+#include "libmultifunc/librefl.h"
+#include <stdio.h>
+#include <stdlib.h>
+
+
+complex cassign(real, imag)
+	double real, imag;
+{
+	complex x;
+	x.re = real;
+	x.im = imag;
+	return x;
+}
+
+
+complex cadd(x,y)
+	complex x,y;
+{
+	complex z;
+	z.re = x.re + y.re;
+	z.im = x.im + y.im;
+	return z;
+}
+
+complex rcmult(x,y)
+	double x;
+    complex y;
+{
+	complex z;
+	z.re = x*y.re;
+	z.im = x*y.im;
+	return z;
+}
+
+complex csub(x,y)
+	complex x,y;
+{
+	complex z;
+	z.re = x.re - y.re;
+	z.im = x.im - y.im;
+	return z;
+}
+
+
+complex cmult(x,y)
+	complex x,y;
+{
+	complex z;
+	z.re = x.re*y.re - x.im*y.im;
+	z.im = x.re*y.im + x.im*y.re;
+	return z;
+}
+
+complex cdiv(x,y)
+	complex x,y;
+{
+	complex z;
+	z.re = (x.re*y.re + x.im*y.im)/(y.re*y.re + y.im*y.im);
+	z.im = (x.im*y.re - x.re*y.im)/(y.re*y.re + y.im*y.im);
+	return z;
+}
+
+complex cexp(b)
+	complex b;
+{
+	complex z;
+	double br,bi;
+	br=b.re;
+	bi=b.im;
+	z.re = exp(br)*cos(bi);
+	z.im = exp(br)*sin(bi);
+	return z;
+}
+
+
+complex csqrt(z)    //see Schaum`s Math Handbook p. 22, 6.6 and 6.10
+	complex z;
+{
+	complex c;
+	double zr,zi,x,y,r,w;
+
+	zr=z.re;
+	zi=z.im;
+
+	if (zr==0.0 && zi==0.0)
+	{
+    c.re=0.0;
+	c.im=0.0;
+    return c;
+	}
+	else
+	{
+		x=fabs(zr);
+		y=fabs(zi);
+		if (x>y)
+		{
+			r=y/x;
+			w=sqrt(x)*sqrt(0.5*(1.0+sqrt(1.0+r*r)));
+		}
+		else
+		{
+			r=x/y;
+			w=sqrt(y)*sqrt(0.5*(r+sqrt(1.0+r*r)));
+		}
+		if (zr >=0.0)
+		{
+			c.re=w;
+			c.im=zi/(2.0*w);
+		}
+		else
+		{
+			c.im=(zi >= 0) ? w : -w;
+			c.re=zi/(2.0*c.im);
+		}
+		return c;
+	}
+}
+
+complex ccos(b)
+	complex b;
+{
+	complex neg,negb,zero,two,z,i,bi,negbi;
+	zero = cassign(0.0,0.0);
+	two = cassign(2.0,0.0);
+	i = cassign(0.0,1.0);
+	bi = cmult(b,i);
+	negbi = csub(zero,bi);
+	z = cdiv(cadd(cexp(bi),cexp(negbi)),two);
+	return z;
+}
+
+// normalized and modified erf
+//   |
+// 1 +                __  - - - -
+//   |             _
+//	 |            _
+//   |        __
+// 0 + - - -
+//   |-------------+------------+--
+//   0           center       n_sub    --->
+//                                     ind
+//
+// n_sub = total no. of bins(or sublayers)
+// ind = x position: 0 to max
+// nu = max x to integration
+double err_mod_func(n_sub, ind, nu)
+	double n_sub,nu, ind;
+{
+	if (nu == 0.0)
+		nu = 1e-14;
+	if (n_sub == 0.0)
+		n_sub = 1.0;
+
+	double center, func;
+	//ind = (n_sub-1.0)/2.0-1.0 +ind;
+	center = n_sub/2.0;
+	// transform it so that min(ind) = 0
+	ind -= center;
+	// normalize by max limit
+	ind /= center;
+	// divide by sqrt(2) to get Gaussian func
+	nu /= sqrt(2.0);
+	ind *= nu;
+	// re-scale and normalize it so that max(erf)=1, min(erf)=0
+	func = erf(ind)/erf(nu)/2.0;
+	// shift it by +0.5 in y-direction so that min(erf) = 0
+	func += 0.5;
+
+	return func;
+}
+double linearfunc(n_sub, ind, nu)
+	double n_sub,nu, ind;
+{
+	if (n_sub == 0.0)
+		n_sub = 1.0;
+
+	double bin_size, func;
+	bin_size = 1.0/n_sub;  //size of each sub-layer
+	// rescale
+	ind *= bin_size;
+	func = ind;
+
+	return func;
+}
+// use the right hand side from the center of power func
+double power_r(n_sub, ind, nu)
+	double n_sub, nu, ind;
+{
+	if (nu == 0.0)
+		nu = 1e-14;
+	if (n_sub == 0.0)
+		n_sub = 1.0;
+
+	double bin_size,func;
+	bin_size = 1.0/n_sub;  //size of each sub-layer
+	// rescale
+	ind *= bin_size;
+	func = pow(ind, nu);
+
+	return func;
+}
+// use the left hand side from the center of power func
+double power_l(n_sub, ind, nu)
+	double n_sub, nu, ind;
+{
+	if (nu == 0.0)
+		nu = 1e-14;
+	if (n_sub == 0.0)
+		n_sub = 1.0;
+
+	double bin_size, func;
+	bin_size = 1.0/n_sub;  //size of each sub-layer
+	// rescale
+	ind *= bin_size;
+	func = 1.0-pow((1.0-ind),nu);
+
+	return func;
+}
+// use 1-exp func from x=0 to x=1
+double exp_r(n_sub, ind, nu)
+	double n_sub, nu, ind;
+{
+	if (nu == 0.0)
+		nu = 1e-14;
+	if (n_sub == 0.0)
+		n_sub = 1.0;
+
+	double bin_size, func;
+	bin_size = 1.0/n_sub;  //size of each sub-layer
+	// rescale
+	ind *= bin_size;
+	// modify func so that func(0) =0 and func(max)=1
+	func = 1.0-exp(-nu*ind);
+	// normalize by its max
+	func /= (1.0-exp(-nu));
+
+	return func;
+}
+
+// use the left hand side mirror image of exp func
+double exp_l(n_sub, ind, nu)
+	double n_sub, nu, ind;
+{
+	if (nu == 0.0)
+		nu = 1e-14;
+	if (n_sub == 0.0)
+		n_sub = 1.0;
+
+	double bin_size, func;
+	bin_size = 1.0/n_sub;  //size of each sub-layer
+	// rescale
+	ind *= bin_size;
+	// modify func
+	func = exp(-nu*(1.0-ind))-exp(-nu);
+	// normalize by its max
+	func /= (1.0-exp(-nu));
+
+	return func;
+}
+
+// To select function called
+// At nu = 0 (singular point), call line function
+double intersldfunc(fun_type, n_sub, i, nu, sld_l, sld_r)
+	double n_sub, nu, sld_l, sld_r,i;
+	int fun_type;
+{
+	double sld_i, func;
+	// this condition protects an error from the singular point
+	if (nu == 0.0){
+		nu = 1e-13;
+	}
+	// select func
+	switch(fun_type){
+		case 1 :
+			func = power_r(n_sub, i, nu);
+			break;
+		case 2 :
+			func = power_l(n_sub, i, nu);
+			break;
+		case 3 :
+			func = exp_r(n_sub, i, nu);
+			break;
+		case 4 :
+			func = exp_l(n_sub, i, nu);
+			break;
+		case 5 :
+			func = linearfunc(n_sub, i, nu);
+			break;
+		default:
+			func = err_mod_func(n_sub, i, nu);
+			break;
+	}
+	// compute sld
+	if (sld_r>sld_l){
+		sld_i = (sld_r-sld_l)*func+sld_l; //sld_cal(sld[i],sld[i+1],n_sub,dz,thick);
+	}
+	else if (sld_r<sld_l){
+		func = 1.0-func;
+		sld_i = (sld_l-sld_r)*func+sld_r; //sld_cal(sld[i],sld[i+1],n_sub,dz,thick);
+	}
+	else{
+		sld_i = sld_r;
+	}
+	return sld_i;
+}
+
+
+// used by refl.c
+double interfunc(fun_type, n_sub, i, sld_l, sld_r)
+	double n_sub, sld_l, sld_r, i;
+	int fun_type;
+{
+	double sld_i, func;
+	switch(fun_type){
+		case 0 :
+			func = err_mod_func(n_sub, i, 2.5);
+			break;
+		default:
+			func = linearfunc(n_sub, i, 1.0);
+			break;
+	}
+	if (sld_r>sld_l){
+		sld_i = (sld_r-sld_l)*func+sld_l; //sld_cal(sld[i],sld[i+1],n_sub,dz,thick);
+	}
+	else if (sld_r<sld_l){
+		func = 1.0-func;
+		sld_i = (sld_l-sld_r)*func+sld_r; //sld_cal(sld[i],sld[i+1],n_sub,dz,thick);
+	}
+	else{
+		sld_i = sld_r;
+	}
+	return sld_i;
+}
Index: sansmodels/src/sans/models/c_extensions/libmultifunc/librefl.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/libmultifunc/librefl.h	(revision 0164899a491d20467a714225f7ea955c852265f3)
+++ sansmodels/src/sans/models/c_extensions/libmultifunc/librefl.h	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -0,0 +1,37 @@
+#if !defined(o_h)
+#define librefl_h
+
+typedef struct {
+	double re;
+	double im;
+} complex;
+
+typedef struct {
+	complex a;
+	complex b;
+	complex c;
+	complex d;
+} matrix;
+
+complex cassign(double real, double imag);
+
+complex cadd(complex x,complex y);
+
+complex rcmult(double x,complex y);
+
+complex csub(complex x,complex y);
+
+complex cmult(complex x,complex y);
+
+complex cdiv(complex x,complex y);
+
+complex cexp(complex b);
+
+complex csqrt(complex z);
+
+complex ccos(complex b);
+
+double intersldfunc(int fun_type, double n_sub, double i, double nu, double sld_l, double sld_r);
+double interfunc(int fun_type, double n_sub, double i, double sld_l, double sld_r);
+double linePq(int fun_type, double thick, double sld_in, double sld_out,double r, double q);
+#endif
Index: sansmodels/src/sans/models/c_extensions/onion.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/onion.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_extensions/onion.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -1,4 +1,4 @@
 /**
- * Scattering model for a sphere
+ * Scattering model for a onion
  */
 
@@ -7,5 +7,5 @@
 #include <stdio.h>
 #include <stdlib.h>
-
+// some details can be found in sld_cal.c
 double so_kernel(double dp[], double q) {
 	int n = dp[0];
@@ -107,7 +107,7 @@
 
                         vol = 4.0 * pi / 3.0 * r * r * r;
-                        if (j == 1 && fabs(sld_in[i]-sld_solv) < 1e-04*fabs(sld_solv) && A[i]==0.0){
-                        	vol_sub += (vol_pre - vol);
-                        }
+                        //if (j == 1 && fabs(sld_in[i]-sld_solv) < 1e-04*fabs(sld_solv) && A[i]==0.0){
+                        //	vol_sub += (vol_pre - vol);
+                        //}
                         f += vol * (contr * (fun) + (sld_in[i]-slope[i]) * bes);
                         }
@@ -148,7 +148,7 @@
                                 }
                             vol = 4.0 * pi / 3.0 * r * r * r;
-                            if (j == 1 && fabs(sld_in[i]-sld_solv) < 1e-04*fabs(sld_solv) && fun_type[i]==0){
-                            	vol_sub += (vol_pre - vol);
-                            }
+                            //if (j == 1 && fabs(sld_in[i]-sld_solv) < 1e-04*fabs(sld_solv) && fun_type[i]==0){
+                            //	vol_sub += (vol_pre - vol);
+                            //}
                             f += vol * (bes * contr + fun * slope[i]);
                             }
@@ -157,5 +157,5 @@
 
         }
-    vol += vol_sub;
+    //vol += vol_sub;
     f2 = f * f / vol * 1.0e8;
 	f2 *= scale;
Index: sansmodels/src/sans/models/c_extensions/refl.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/refl.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_extensions/refl.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -1,8 +1,10 @@
 /**
- * Scattering model for a sphere
+ *  model for NR
  */
-
+// The original code, of which work was not DANSE funded,
+// was provided by J. Cho.
 #include <math.h>
 #include "refl.h"
+#include "libmultifunc/librefl.h"
 #include <stdio.h>
 #include <stdlib.h>
@@ -10,251 +12,4 @@
 #define lamda 4.62
 
-typedef struct {
-	double re;
-	double im;
-} complex;
-
-typedef struct {
-	complex a;
-	complex b;
-	complex c;
-	complex d;
-} matrix;
-
-complex cassign(real, imag)
-	double real, imag;
-{
-	complex x;
-	x.re = real;
-	x.im = imag;
-	return x;
-}
-
-
-complex cadd(x,y)
-	complex x,y;
-{
-	complex z;
-	z.re = x.re + y.re;
-	z.im = x.im + y.im;
-	return z;
-}
-
-complex rcmult(x,y)
-	double x;
-    complex y;
-{
-	complex z;
-	z.re = x*y.re;
-	z.im = x*y.im;
-	return z;
-}
-
-complex csub(x,y)
-	complex x,y;
-{
-	complex z;
-	z.re = x.re - y.re;
-	z.im = x.im - y.im;
-	return z;
-}
-
-
-complex cmult(x,y)
-	complex x,y;
-{
-	complex z;
-	z.re = x.re*y.re - x.im*y.im;
-	z.im = x.re*y.im + x.im*y.re;
-	return z;
-}
-
-complex cdiv(x,y)
-	complex x,y;
-{
-	complex z;
-	z.re = (x.re*y.re + x.im*y.im)/(y.re*y.re + y.im*y.im);
-	z.im = (x.im*y.re - x.re*y.im)/(y.re*y.re + y.im*y.im);
-	return z;
-}
-
-complex cexp(b)
-	complex b;
-{
-	complex z;
-	double br,bi;
-	br=b.re;
-	bi=b.im;
-	z.re = exp(br)*cos(bi);
-	z.im = exp(br)*sin(bi);
-	return z;
-}
-
-
-complex csqrt(z)   /* see Schaum`s Math Handbook p. 22, 6.6 and 6.10 */
-	complex z;
-{
-	complex c;
-	double zr,zi,x,y,r,w;
-
-	zr=z.re;
-	zi=z.im;
-
-	if (zr==0.0 && zi==0.0)
-	{
-    c.re=0.0;
-	c.im=0.0;
-    return c;
-	}
-	else
-	{
-		x=fabs(zr);
-		y=fabs(zi);
-		if (x>y)
-		{
-			r=y/x;
-			w=sqrt(x)*sqrt(0.5*(1.0+sqrt(1.0+r*r)));
-		}
-		else
-		{
-			r=x/y;
-			w=sqrt(y)*sqrt(0.5*(r+sqrt(1.0+r*r)));
-		}
-		if (zr >=0.0)
-		{
-			c.re=w;
-			c.im=zi/(2.0*w);
-		}
-		else
-		{
-			c.im=(zi >= 0) ? w : -w;
-			c.re=zi/(2.0*c.im);
-		}
-		return c;
-	}
-}
-
-complex ccos(b)
-	complex b;
-{
-	complex neg,negb,zero,two,z,i,bi,negbi;
-	zero = cassign(0.0,0.0);
-	two = cassign(2.0,0.0);
-	i = cassign(0.0,1.0);
-	bi = cmult(b,i);
-	negbi = csub(zero,bi);
-	z = cdiv(cadd(cexp(bi),cexp(negbi)),two);
-	return z;
-}
-
-double errfunc(n_sub, i)
-	double n_sub;
-	int i;
-{
-	double bin_size, ind, func;
-	ind = i;
-	// i range = [ -4..4], x range = [ -2.5..2.5]
-	bin_size = n_sub/2.0/2.5;  //size of each sub-layer
-	// rescale erf so that 0 < erf < 1 in -2.5 <= x <= 2.5
-	func = (erf(ind/bin_size)/2.0+0.5);
-	return func;
-}
-
-double linefunc(n_sub, i)
-	double n_sub;
-	int i;
-{
-	double bin_size, ind, func;
-	ind = i + 0.5;
-	// i range = [ -4..4], x range = [ -2.5..2.5]
-	bin_size = 1.0/n_sub;  //size of each sub-layer
-	// rescale erf so that 0 < erf < 1 in -2.5 <= x <= 2.5
-	func = ((ind + floor(n_sub/2.0))*bin_size);
-	return func;
-}
-
-double parabolic_r(n_sub, i)
-	double n_sub;
-	int i;
-{
-	double bin_size, ind, func;
-	ind = i + 0.5;
-	// i range = [ -4..4], x range = [ 0..1]
-	bin_size = 1.0/n_sub;  //size of each sub-layer; n_sub = 0 is a singular point (error)
-	func = ((ind + floor(n_sub/2.0))*bin_size)*((ind + floor(n_sub/2.0))*bin_size);
-	return func;
-}
-
-double parabolic_l(n_sub, i)
-	double n_sub;
-	int i;
-{
-	double bin_size,ind, func;
-	ind = i + 0.5;
-	bin_size = 1.0/n_sub;  //size of each sub-layer; n_sub = 0 is a singular point (error)
-	func =1.0-(((ind + floor(n_sub/2.0))*bin_size) - 1.0) *(((ind + floor(n_sub/2.0))*bin_size) - 1.0);
-	return func;
-}
-
-double cubic_r(n_sub, i)
-	double n_sub;
-	int i;
-{
-	double bin_size,ind, func;
-	ind = i + 0.5;
-	// i range = [ -4..4], x range = [ 0..1]
-	bin_size = 1.0/n_sub;  //size of each sub-layer; n_sub = 0 is a singular point (error)
-	func = ((ind+ floor(n_sub/2.0))*bin_size)*((ind + floor(n_sub/2.0))*bin_size)*((ind + floor(n_sub/2.0))*bin_size);
-	return func;
-}
-
-double cubic_l(n_sub, i)
-	double n_sub;
-	int i;
-{
-	double bin_size,ind, func;
-	ind = i + 0.5;
-	bin_size = 1.0/n_sub;  //size of each sub-layer; n_sub = 0 is a singular point (error)
-	func = 1.0+(((ind + floor(n_sub/2.0)))*bin_size - 1.0)*(((ind + floor(n_sub/2.0)))*bin_size - 1.0)*(((ind + floor(n_sub/2.0)))*bin_size - 1.0);
-	return func;
-}
-
-double interfunc(fun_type, n_sub, i, sld_l, sld_r)
-	double n_sub, sld_l, sld_r;
-	int fun_type, i;
-{
-	double sld_i, func;
-	switch(fun_type){
-		case 1 :
-			func = linefunc(n_sub, i);
-			break;
-		case 2 :
-			func = parabolic_r(n_sub, i);
-			break;
-		case 3 :
-			func = parabolic_l(n_sub, i);
-			break;
-		case 4 :
-			func = cubic_r(n_sub, i);
-			break;
-		case 5 :
-			func = cubic_l(n_sub, i);
-			break;
-		default:
-			func = errfunc(n_sub, i);
-			break;
-	}
-	if (sld_r>sld_l){
-		sld_i = (sld_r-sld_l)*func+sld_l; //sld_cal(sld[i],sld[i+1],n_sub,dz,thick);
-	}
-	else if (sld_r<sld_l){
-		func = 1.0-func;
-		sld_i = (sld_l-sld_r)*func+sld_r; //sld_cal(sld[i],sld[i+1],n_sub,dz,thick);
-	}
-	else{
-		sld_i = sld_r;
-	}
-	return sld_i;
-}
 
 double re_kernel(double dp[], double q) {
@@ -268,5 +23,5 @@
 	double background = dp[6];
 
-	double sld[n+2],sld_im[n+2],thick_inter[n+2],thick[n+2],total_thick;
+	double sld[n+2],thick_inter[n+2],thick[n+2],total_thick;
 	fun_type[0] = dp[3];
 	for (i =1; i<=n; i++){
@@ -275,12 +30,9 @@
 		thick[i] = dp[i+26];
 		fun_type[i] = dp[i+36];
-		sld_im[i] = dp[i+46];
-
 		total_thick += thick[i] + thick_inter[i];
 	}
 	sld[0] = sld_sub;
 	sld[n+1] = sld_super;
-	sld_im[0] = fabs(dp[0+56]);
-	sld_im[n+1] = fabs(dp[1+56]);
+
 	thick[0] = total_thick/5.0;
 	thick[n+1] = total_thick/5.0;
@@ -288,8 +40,8 @@
 	thick_inter[n+1] = 0.0;
 
-	double nsl=21.0; //nsl = Num_sub_layer:  MUST ODD number in double //no other number works now
-	int n_s, floor_nsl;
+	double nsl=21.0; //nsl = Num_sub_layer:
+	int n_s;
     double sld_i,sldim_i,dz,phi,R,ko2;
-    double sign,erfunc;
+    double sign,erfunc, fun;
     double pi;
 	complex  inv_n,phi1,alpha,alpha2,kn,fnm,fnp,rn,Xn,nn,nn2,an,nnp1,one,zero,two,n_sub,n_sup,knp1,Xnp1;
@@ -299,10 +51,8 @@
 	two= cassign(0.0,-2.0);
 
-	floor_nsl = floor(nsl/2.0);
-
 	//Checking if floor is available.
 	//no imaginary sld inputs in this function yet
-    n_sub=cassign(1.0-sld_sub*pow(lamda,2.0)/(2.0*pi),pow(lamda,2.0)/(2.0*pi)*sld_im[0]);
-    n_sup=cassign(1.0-sld_super*pow(lamda,2.0)/(2.0*pi),pow(lamda,2.0)/(2.0*pi)*sld_im[n+1]);
+    n_sub=cassign(1.0-sld_sub*pow(lamda,2.0)/(2.0*pi),0.0);
+    n_sup=cassign(1.0-sld_super*pow(lamda,2.0)/(2.0*pi),0.0);
     ko2 = pow(2.0*pi/lamda,2.0);
 
@@ -318,7 +68,11 @@
     // iteration for # of layers +sub from the top
     for (i=1;i<=n+1; i++){
+    	if (fun_type[i-1]==1)
+    		fun = 5;
+    	else
+			fun = 0;
 		//iteration for 9 sub-layers
 		for (j=0;j<2;j++){
-			for (n_s=-floor_nsl;n_s<=floor_nsl; n_s++){
+			for (n_s=0;n_s<nsl; n_s++){
 				if (j==1){
 					if (i==n+1)
@@ -326,22 +80,15 @@
 					dz = thick[i];
 					sld_i = sld[i];
-					sldim_i = sld_im[i];
 				}
 				else{
-					dz = thick_inter[i-1]/nsl;
+					dz = thick_inter[i-1]/nsl;//nsl;
 					if (sld[i-1] == sld[i]){
 						sld_i = sld[i];
 					}
 					else{
-						sld_i = interfunc(fun_type[i-1],nsl, n_s, sld[i-1], sld[i]);
-					}
-					if (sld_im[i-1] == sld_im[i]){
-						sldim_i = sld_im[i];
-					}
-					else{
-						sldim_i = interfunc(fun_type[i-1],nsl, n_s, sld_im[i-1], sld_im[i]);
+						sld_i = intersldfunc(fun,nsl, n_s+0.5, 2.5, sld[i-1], sld[i]);
 					}
 				}
-				nn = cassign(1.0-sld_i*pow(lamda,2.0)/(2.0*pi),pow(lamda,2.0)/(2.0*pi)*sldim_i);
+				nn = cassign(1.0-sld_i*pow(lamda,2.0)/(2.0*pi),0.0);
 				nn2=cmult(nn,nn);
 
@@ -375,11 +122,11 @@
 }
 /**
- * Function to evaluate 1D scattering function
- * @param pars: parameters of the sphere
+ * Function to evaluate NR function
+ * @param pars: parameters
  * @param q: q-value
  * @return: function value
  */
 double refl_analytical_1D(ReflParameters *pars, double q) {
-	double dp[59];
+	double dp[47];
 
 	dp[0] = pars->n_layers;
@@ -387,5 +134,5 @@
 	dp[2] = pars->thick_inter0;
 	dp[3] = pars->func_inter0;
-	dp[4] = pars->sld_sub0;
+	dp[4] = pars->sld_bottom0;
 	dp[5] = pars->sld_medium;
 	dp[6] = pars->background;
@@ -435,24 +182,10 @@
 	dp[46] = pars->func_inter10;
 
-	dp[47] = pars->sldIM_flat1;
-	dp[48] = pars->sldIM_flat2;
-	dp[49] = pars->sldIM_flat3;
-	dp[50] = pars->sldIM_flat4;
-	dp[51] = pars->sldIM_flat5;
-	dp[52] = pars->sldIM_flat6;
-	dp[53] = pars->sldIM_flat7;
-	dp[54] = pars->sldIM_flat8;
-	dp[55] = pars->sldIM_flat9;
-	dp[56] = pars->sldIM_flat10;
-
-	dp[57] = pars->sldIM_sub0;
-	dp[58] = pars->sldIM_medium;
-
 	return re_kernel(dp, q);
 }
 
 /**
- * Function to evaluate 2D scattering function
- * @param pars: parameters of the sphere
+ * Function to evaluate NR function
+ * @param pars: parameters of NR
  * @param q: q-value
  * @return: function value
Index: sansmodels/src/sans/models/c_extensions/refl.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/refl.h	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_extensions/refl.h	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -1,2 +1,4 @@
+// The original code, of which work was not DANSE funded,
+// was provided by J. Cho.
 #if !defined(o_h)
 #define refl_h
@@ -7,27 +9,21 @@
  //[PYTHONCLASS] = ReflModel
  //[DISP_PARAMS] = thick_inter0
- //[DESCRIPTION] =<text>Form factor of mutishells normalized by the volume. Here each shell is described
- //						 by an exponential function;
- //							I)
- //							For A_shell != 0,
- //							f(r) = B*exp(A_shell*(r-r_in)/thick_shell)+C
- //                         where
- //								B=(sld_out-sld_in)/(exp(A_shell)-1)
- //								C=sld_in-B.
- //							Note that in the above case,
- //								the function becomes a linear function
- //								as A_shell --> 0+ or 0-.
- //							II)
- //							For the exact point of A_shell == 0,
- //							f(r) = sld_in ,i.e., it crosses over flat function
- //							Note that the 'sld_out' becaomes NULL in this case.
- //
- //				background:background,
- //				rad_core: radius of sphere(core)
- //				thick_shell#:the thickness of the shell#
- //				sld_core: the SLD of the sphere
- //				sld_solv: the SLD of the solvent
- //				sld_shell: the SLD of the shell#
- //				A_shell#: the coefficient in the exponential function
+ //[DESCRIPTION] =<text>Calculate neutron reflectivity using the Parratt iterative formula
+ //				Parameters:
+ //				background:background
+ //				scale: scale factor
+ //				sld_bottom0: the SLD of the substrate
+ //				sld_medium: the SLD of the incident medium
+ //					or superstrate
+ //				sld_flatN: the SLD of the flat region of
+ //					the N'th layer
+ //				thick_flatN: the thickness of the flat
+ //					region of the N'th layer
+ //				func_interN: the function used to describe
+ //					the interface of the N'th layer
+ //				thick_interN: the thickness of the interface
+ //					of the N'th layer
+ //				Note: the layer number starts to increase
+ //					from the bottom (substrate) to the top.
  //		</text>
  //[FIXED]=  <text></text>
@@ -48,7 +44,7 @@
 	//  [DEFAULT]=func_inter0= 0
 	double func_inter0;
-	///	sld_sub0 [1/A^(2)]
-	//  [DEFAULT]=sld_sub0= 2.07e-6 [1/A^(2)]
-	double sld_sub0;
+	///	sld_bottom0 [1/A^(2)]
+	//  [DEFAULT]=sld_bottom0= 2.07e-6 [1/A^(2)]
+	double sld_bottom0;
 	///	sld_medium [1/A^(2)]
 	//  [DEFAULT]=sld_medium= 1.0e-6 [1/A^(2)]
@@ -142,28 +138,4 @@
     double func_inter10;
 
-    //  [DEFAULT]=sldIM_flat1=0
-    double sldIM_flat1;
-    //  [DEFAULT]=sldIM_flat2=0
-    double sldIM_flat2;
-    //  [DEFAULT]=sldIM_flat3=0
-    double sldIM_flat3;
-    //  [DEFAULT]=sldIM_flat4=0
-    double sldIM_flat4;
-    //  [DEFAULT]=sldIM_flat5=0
-    double sldIM_flat5;
-    //  [DEFAULT]=sldIM_flat6=0
-    double sldIM_flat6;
-    //  [DEFAULT]=sldIM_flat7=0
-    double sldIM_flat7;
-    //  [DEFAULT]=sldIM_flat8=0
-    double sldIM_flat8;
-    //  [DEFAULT]=sldIM_flat9=0
-    double sldIM_flat9;
-    //  [DEFAULT]=sldIM_flat10=0
-    double sldIM_flat10;
-    //  [DEFAULT]=sldIM_sub0=0
-    double sldIM_sub0;
-    //  [DEFAULT]=sldIM_medium=0
-    double sldIM_medium;
 
 } ReflParameters;
Index: sansmodels/src/sans/models/c_extensions/sld_cal.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/sld_cal.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
+++ sansmodels/src/sans/models/c_extensions/sld_cal.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -0,0 +1,46 @@
+/**
+ * SLD Calculator
+ * @author: Jae Hie Cho / UTK
+ */
+
+#include "sld_cal.h"
+#include "libmultifunc/librefl.h"
+#include <math.h>
+
+
+/**
+ * Function to calculate sld
+ * @param pars: parameters
+ * @param x: independent param-value
+ * @return: sld value
+ */
+double sld_cal_analytical_1D(SLDCalParameters *pars, double x) {
+	double fun, nsl, n_s, fun_coef, sld_l, sld_r, sld_out;
+
+	fun = pars->fun_type;
+	nsl = pars->npts_inter;
+	n_s = pars->shell_num;
+	fun_coef = pars->nu_inter;
+	sld_l = pars-> sld_left;
+	sld_r = pars-> sld_right;
+
+	int fun_type = floor(fun);
+
+	sld_out = intersldfunc(fun_type, nsl, n_s, fun_coef, sld_l, sld_r);
+
+	return sld_out;
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters
+ * @param q: q-value
+ * @return: function value
+ */
+double sld_cal_analytical_2D(SLDCalParameters *pars, double x, double phi) {
+	return sld_cal_analytical_1D(pars,x);
+}
+
+double sld_cal_analytical_2DXY(SLDCalParameters *pars, double xx, double xy){
+	return sld_cal_analytical_1D(pars,sqrt(xx*xx+xy*xy));
+}
Index: sansmodels/src/sans/models/c_extensions/sld_cal.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/sld_cal.h	(revision 0164899a491d20467a714225f7ea955c852265f3)
+++ sansmodels/src/sans/models/c_extensions/sld_cal.h	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -0,0 +1,50 @@
+#if !defined(sld_cal_h)
+#define sld_cal_h
+
+/**
+ * To calculate the sld value
+* [PYTHONCLASS] = SLDCalFunc
+* [DISP_PARAMS] = npts_inter
+  [DESCRIPTION] =<text>To calculate sld values
+ 				</text>
+	[FIXED]= <text>
+			</text>
+
+ **/
+typedef struct {
+    ///	fun_type
+    //  [DEFAULT]=fun_type=0
+    double fun_type;
+
+    /// npts_inter
+    //  [DEFAULT]=npts_inter= 21
+    double npts_inter;
+
+    /// shell_num
+    //  [DEFAULT]=shell_num= 0
+    double shell_num;
+
+    /// nu_inter
+    //  [DEFAULT]=nu_inter= 2.5
+    double nu_inter;
+
+    /// sld_left [1/A^(2)]
+    //  [DEFAULT]=sld_left= 0 [1/A^(2)]
+    double sld_left;
+
+    /// sld_right [1/A^(2)]
+    //  [DEFAULT]=sld_right= 0 [1/A^(2)]
+    double sld_right;
+
+} SLDCalParameters;
+
+
+
+/// 1D function
+double sld_cal_analytical_1D(SLDCalParameters *pars, double q);
+
+/// 2D function
+double sld_cal_analytical_2D(SLDCalParameters *pars, double q, double phi);
+double sld_cal_analytical_2DXY(SLDCalParameters *pars, double qx, double qy);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/spheresld.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/spheresld.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
+++ sansmodels/src/sans/models/c_extensions/spheresld.c	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -0,0 +1,241 @@
+/**
+ * spheresld model
+ */
+#include <math.h>
+#include "spheresld.h"
+#include "libmultifunc/librefl.h"
+#include <stdio.h>
+#include <stdlib.h>
+
+#define lamda 4.62
+
+
+double sphere_sld_kernel(double dp[], double q) {
+	int n = dp[0];
+	int i,j,k,fun_type[n+2];
+
+	double scale = dp[1];
+	double thick_inter_core = dp[2];
+	double sld_core = dp[4];
+	double sld_solv = dp[5];
+	double background = dp[6];
+	double npts = dp[57]; //number of sub_layers in each interface
+
+	double sld[n+2],thick_inter[n+2],thick[n+2],fun_coef[n+2],total_thick;
+	fun_type[0] = dp[3];
+	fun_coef[0] = fabs(dp[58]);
+	for (i =1; i<=n; i++){
+		sld[i] = dp[i+6];
+		thick_inter[i]= dp[i+16];
+		thick[i] = dp[i+26];
+		fun_type[i] = dp[i+36];
+		fun_coef[i] = fabs(dp[i+46]);
+		total_thick += thick[i] + thick_inter[i];
+	}
+	sld[0] = sld_core;
+	sld[n+1] = sld_solv;
+	thick[0] = dp[59];
+	thick[n+1] = total_thick/5.0;
+	thick_inter[0] = thick_inter_core;
+	thick_inter[n+1] = 0.0;
+	fun_coef[n+1] = 0.0;
+
+	double nsl=npts;//21.0; //nsl = Num_sub_layer:  MUST ODD number in double //no other number works now
+	int n_s;
+	int floor_nsl;
+
+    double sld_i,sld_f,dz,bes,fun,f,vol,vol_pre,vol_sub,qr,r,contr,f2;
+    double sign,slope=0.0;
+    double pi;
+
+    pi = 4.0*atan(1.0);
+    f = 0.0;
+    r = 0.0;
+    vol = 0.0;
+    vol_pre = 0.0;
+    vol_sub = 0.0;
+    sld_f = sld_core;
+    double r0 = 0.0, thick_inter_f;
+
+	//floor_nsl = floor(nsl/2.0);
+
+    dz = 0.0;
+    // iteration for # of shells + core + solvent
+    for (i=0;i<=n+1; i++){
+		//iteration for N sub-layers
+    	//if (fabs(thick[i]) <= 1e-24){
+    	//   continue;
+    	//}
+    	// iteration for flat and interface
+		for (j=0;j<2;j++){
+			// iteration for sub_shells in the interface
+			// starts from #1 sub-layer
+			for (n_s=1;n_s<=nsl; n_s++){
+				// for solvent, it doesn't have an interface
+				if (i==n+1 && j==1)
+					break;
+				// for flat layers
+				if (j==0){
+					dz = thick[i];
+					sld_i = sld[i];
+					slope = 0.0;
+				}
+				// for interfacial sub_shells
+				else{
+					dz = thick_inter[i]/nsl;
+					// find sld_i at the outer boundary of sub-layer #n_s
+					sld_i = intersldfunc(fun_type[i],nsl, n_s, fun_coef[i], sld[i], sld[i+1]);
+					// calculate slope
+					slope= (sld_i -sld_f)/dz;
+				}
+				contr = sld_f-slope*r;
+				// iteration for the left and right boundary of the shells(or sub_shells)
+				for (k=0; k<2; k++){
+					// At r=0, the contribution to I is zero, so skip it.
+					if ( i == 0 && j == 0 && k == 0){
+						continue;
+						}
+					// On the top of slovent there is no interface; skip it.
+					if (i == n+1 && k == 1){
+						continue;
+						}
+					// At the right side (outer) boundary
+					if ( k == 1){
+						sign = 1.0;
+						r += dz;
+						}
+					// At the left side (inner) boundary
+					else{
+						sign = -1.0;
+						}
+					qr = q * r;
+					fun = 0.0;
+					if(qr == 0.0){
+						// sigular point
+						bes = sign * 1.0;
+						}
+					else{
+						// for flat sub-layer
+						bes = sign *  3.0 * (sin(qr) - qr * cos(qr)) / (qr * qr * qr);
+						// with linear slope
+						if (fabs(slope) > 0.0 ){
+							fun = sign * 3.0 * r * (2.0*qr*sin(qr)-((qr*qr)-2.0)*cos(qr))/(qr * qr * qr * qr);
+							}
+						}
+					// update total volume
+					vol = 4.0 * pi / 3.0 * r * r * r;
+					// we won't do the following volume correction for now.
+					// substrate empty area of volume
+					//if (k == 1 && fabs(sld_in[i]-sld_solv) < 1e-04*fabs(sld_solv) && fun_type[i]==0){
+					//	vol_sub += (vol_pre - vol);
+					//}
+					f += vol * (bes * contr + fun * slope);
+				}
+				// remember this sld as sld_f
+				sld_f =sld_i;
+				// no sub-layer iteration (n_s loop) for the flat layer
+				if (j==0)
+					break;
+			}
+		}
+    }
+    //vol += vol_sub;
+    f2 = f * f / vol * 1.0e8;
+	f2 *= scale;
+	f2 += background;
+    return (f2);
+}
+
+/**
+ * Function to evaluate spheresld function
+ * @param pars: parameters of spheresld
+ * @param q: q-value
+ * @return: function value
+ */
+
+double sphere_sld_analytical_1D(SphereSLDParameters *pars, double q) {
+	double dp[60];
+
+	dp[0] = pars->n_shells;
+	dp[1] = pars->scale;
+	dp[2] = pars->thick_inter0;
+	dp[3] = pars->func_inter0;
+	dp[4] = pars->sld_core0;
+	dp[5] = pars->sld_solv;
+	dp[6] = pars->background;
+
+	dp[7] = pars->sld_flat1;
+	dp[8] = pars->sld_flat2;
+	dp[9] = pars->sld_flat3;
+	dp[10] = pars->sld_flat4;
+	dp[11] = pars->sld_flat5;
+	dp[12] = pars->sld_flat6;
+	dp[13] = pars->sld_flat7;
+	dp[14] = pars->sld_flat8;
+	dp[15] = pars->sld_flat9;
+	dp[16] = pars->sld_flat10;
+
+	dp[17] = pars->thick_inter1;
+	dp[18] = pars->thick_inter2;
+	dp[19] = pars->thick_inter3;
+	dp[20] = pars->thick_inter4;
+	dp[21] = pars->thick_inter5;
+	dp[22] = pars->thick_inter6;
+	dp[23] = pars->thick_inter7;
+	dp[24] = pars->thick_inter8;
+	dp[25] = pars->thick_inter9;
+	dp[26] = pars->thick_inter10;
+
+	dp[27] = pars->thick_flat1;
+	dp[28] = pars->thick_flat2;
+	dp[29] = pars->thick_flat3;
+	dp[30] = pars->thick_flat4;
+	dp[31] = pars->thick_flat5;
+	dp[32] = pars->thick_flat6;
+	dp[33] = pars->thick_flat7;
+	dp[34] = pars->thick_flat8;
+	dp[35] = pars->thick_flat9;
+	dp[36] = pars->thick_flat10;
+
+	dp[37] = pars->func_inter1;
+	dp[38] = pars->func_inter2;
+	dp[39] = pars->func_inter3;
+	dp[40] = pars->func_inter4;
+	dp[41] = pars->func_inter5;
+	dp[42] = pars->func_inter6;
+	dp[43] = pars->func_inter7;
+	dp[44] = pars->func_inter8;
+	dp[45] = pars->func_inter9;
+	dp[46] = pars->func_inter10;
+
+	dp[47] = pars->nu_inter1;
+	dp[48] = pars->nu_inter2;
+	dp[49] = pars->nu_inter3;
+	dp[50] = pars->nu_inter4;
+	dp[51] = pars->nu_inter5;
+	dp[52] = pars->nu_inter6;
+	dp[53] = pars->nu_inter7;
+	dp[54] = pars->nu_inter8;
+	dp[55] = pars->nu_inter9;
+	dp[56] = pars->nu_inter10;
+
+	dp[57] = pars->npts_inter;
+	dp[58] = pars->nu_inter0;
+	dp[59] = pars->rad_core0;
+
+	return sphere_sld_kernel(dp, q);
+}
+
+/**
+ * Function to evaluate spheresld function
+ * @param pars: parameters of spheresld
+ * @param q: q-value
+ * @return: function value
+ */
+double sphere_sld_analytical_2D(SphereSLDParameters *pars, double q, double phi) {
+	return sphere_sld_analytical_1D(pars,q);
+}
+
+double sphere_sld_analytical_2DXY(SphereSLDParameters *pars, double qx, double qy){
+	return sphere_sld_analytical_1D(pars,sqrt(qx*qx+qy*qy));
+}
